/*
 * Jalview - A Sequence Alignment Editor and Viewer ($$Version-Rel$$)
 * Copyright (C) $$Year-Rel$$ The Jalview Authors
 * 
 * This file is part of Jalview.
 * 
 * Jalview is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *  
 * Jalview is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty 
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jalview.  If not, see <http://www.gnu.org/licenses/>.
 * The Jalview Authors are detailed in the 'AUTHORS' file.
 */
package jalview.schemes;

import static org.testng.AssertJUnit.assertTrue;

import jalview.gui.JvOptionPane;

import java.util.Map;

import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;

public class DnaCodonTests
{

  @BeforeClass(alwaysRun = true)
  public void setUpJvOptionPane()
  {
    JvOptionPane.setInteractiveMode(false);
    JvOptionPane.setMockResponse(JvOptionPane.CANCEL_OPTION);
  }

  @Test(groups = { "Functional" })
  public void testAmbiguityCodeGeneration()
  {
    assertTrue(ResidueProperties.ambiguityCodes.size() > 0);
  }

  @Test(groups = { "Functional" })
  public void testAmbiguityCodon()
  {
    for (String ac : ResidueProperties.ambiguityCodes.keySet())
    {
      assertTrue("Couldn't resolve GGN as glycine codon",
              ResidueProperties.codonHash2.get("GG" + ac).equals("G"));
    }
  }

  @Test(groups = { "Functional" })
  public void regenerateCodonTable()
  {
    for (Map.Entry<String, String> codon : ResidueProperties.codonHash2
            .entrySet())
    {
      System.out.println("ResidueProperties.codonHash2.set(\""
              + codon.getKey() + "\", \"" + codon.getValue() + "\");");
    }
  }
}
